Magellan Linux

Diff of /tags/installer-simple-0_4_90_20140703_1/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2321 by niro, Fri Jan 3 13:15:44 2014 UTC revision 2401 by niro, Tue Jan 7 13:16:16 2014 UTC
# Line 1  Line 1 
1  #!/bin/sh  #!/bin/bash
2    # $Id$
3  #  #
4  # $Header: /home/cvsd/alx-cvs/alx-src/alxinstall-ng/bin/alxinstall-ng.sh,v 1.15 2008-06-28 00:37:45 niro Exp $  # Simple Installation Script
5  #  # merged from alxinstall-ng and mcore-installer
 # AutoSta_LX Installation Script  
6  #  #
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
 # <rogalla@augusta-bochum.de>  
 #  
 #  
 # Install Navigation Gui  
8  #  #
9    
10  #images: (get ${CDIMAGENAME})  # ignore the environment
11  source /mnt/cdrom/system/images.conf  LC_ALL=C
12    # include dir
13    INSTALLER_LIBDIR="%LIBDIR%"
14    
15  #Includes  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16  source /usr/lib/alxinstall-ng/functions/findhdd.sh > /dev/null  # -> now in images.conf
17  ### bugfix ###############################  CURRENTLINE=0
 cdromdev="$(echo ${cdromdev} | sed 's/ //')"  
 ########################################  
18    
19  ### System/Config Version  die()
20  VERSION="%VERSIONTAG%"  {
21  TITLE="alxinstall-ng - ${VERSION}"   echo "Error: $@"
22     exit 1
23    }
24    
25  CDPATH="/mnt/cdrom"  # load common includes
26  INSTALLPATH="/mnt/magellan"  for inc in %SYSCONFDIR%/installer.conf
27    do
28     if [ -e ${inc} ]
29     then
30     source "${inc}"
31     else
32     die "'${inc}' not found"
33     fi
34    done
35    
36  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
37    # -> now in images.conf
38    CDIMAGENAME=""
39    TOTALLINES=""
40  CURRENTLINE=0  CURRENTLINE=0
41  #TOTALLINES=11072 # -> now in images.conf  if [ -e /mnt/cdrom/system/images.conf ]
42    then
43     source /mnt/cdrom/system/images.conf
44     # check if all required variables are set
45     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
46     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
47    else
48     die "/mnt/cdrom/system/images.conf not found"
49    fi
50    
51    # includes
52    source ${INSTALLER_LIBDIR}/functions/hwdetection.sh
53    
54    ### System/Config Version
55    VERSION="%VERSIONTAG%"
56    TITLE="${DEFAULT_TITLE} - ${VERSION}"
57    
58    CDROOT="${DEFAULT_CDROOT}"
59    INSTALLROOT="${DEFAULT_INSTALLROOT}"
60    
61  # standard kernel opts  # standard kernel opts
62  KERNELOPTS="quiet video=1024x768"  KERNELOPTS="quiet video=1024x768"
# Line 46  SPECIALDEVICE="" Line 73  SPECIALDEVICE=""
73  FORMFACTOR="desktop"  FORMFACTOR="desktop"
74    
75  # target filesystem  # target filesystem
76  FORMAT_FILESYSTEM="ext4"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
77    
78  #################################################  #################################################
79  #  DIALOG BOXEN #  #  DIALOG BOXEN #
80  #################################################  #################################################
81    
82  die()  dialog_die()
83  {  {
84   ERROR=$1   ERROR="$1"
85   RETVAL=$?   RETVAL="$?"
86   dialog_install_failure   dialog_install_failure
87   exit 1   exit 1
88  }  }
89    
90  dialog_warning()  dialog_warning()
91  {  {
92   dialog \   local retval
93   --backtitle "${TITLE}" \  
94   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
95   --defaultno \   retval=$?
96   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
97   then   then
98   clear   clear
99   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
100   exit 1   exit 1
101   fi   fi
102  }  }
103    
104  dialog_setup_hdd_info()  dialog_setup_hdd_info()
105  {  {
  local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
106   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="$(echo $HDD | sed 's/\/dev\///')"
107    
108   dialog \   dialog \
# Line 137  dialog_setup_system_menu() Line 144  dialog_setup_system_menu()
144   "" "" \   "" "" \
145   "" "\Z1Experten Modi:\Zn" \   "" "\Z1Experten Modi:\Zn" \
146   "2" "Normale IDE-Disk (Manuell)" \   "2" "Normale IDE-Disk (Manuell)" \
  "3" "Flash-Speicher (Manuell)")  
147   RES=$?   RES=$?
148   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
149   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
150   then   then
151   case "${i}" in   case "${i}" in
152   "1") run_install_auto ;;   "1") run_install_auto ;;
153           "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
154   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
155   esac   esac
156   fi   fi
# Line 156  dialog_hardware_detection() Line 161  dialog_hardware_detection()
161   local i   local i
162   local hwtmp   local hwtmp
163    
164   if [ -x $(which mktemp &> /dev/null) ]   if [ -x $(type -P mktemp) ]
165   then   then
166   hwtmp="$(mktemp)"   hwtmp="$(mktemp)"
167   else   else
168   hwtmp="/tmp/hwtmp.sh"   hwtmp="/tmp/hwtmp.sh"
169   fi   fi
170    
171   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
172    
173   echo "dialog \\"  > ${hwtmp}   echo "dialog \\"  > ${hwtmp}
174   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}
# Line 173  dialog_hardware_detection() Line 178  dialog_hardware_detection()
178   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}
179   echo " Festplatten:\n \\" >> ${hwtmp}   echo " Festplatten:\n \\" >> ${hwtmp}
180    
181   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
182   then   then
183   for i in ${scsidisks}   for i in ${ALL_DISKS}
184   do   do
185   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
186   done   done
187   fi   fi
188    
189   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
190   then   then
191   for i in ${idedisks}   echo " \n \\" >> ${hwtmp}
192     echo " CDROM Laufwerke:\n \\" >> ${hwtmp}
193     for i in ${ALL_CDROMS}
194   do   do
195   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
196   done   done
197   fi   fi
198    
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
  fi  
   
199   # other devices   # other devices
200   run_hardware_detection   run_hardware_detection
201   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
# Line 266  dialog_setup_hdd_partitions_manuell() Line 258  dialog_setup_hdd_partitions_manuell()
258   fi   fi
259  }  }
260    
261  dialog_setup_hdd_partitions_manuell_flash()  dialog_setup_hdd_partitions_auto()
262  {  {
263   local i   local i
264    
# Line 298  dialog_setup_hdd_partitions_manuell_flas Line 290  dialog_setup_hdd_partitions_manuell_flas
290   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
291   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
292   then   then
293   dialog_setup_hdd_info_flash   dialog_setup_hdd_info_auto
294   setup_hdd_partitions_manuell_flash   dialog_setup_hdd_create_partitions
295     setup_hdd_partitions_auto
296   fi   fi
297   fi   fi
298  }  }
299    
300  dialog_setup_hdd_partitions_auto()  run_hardware_detection_disks()
301  {  {
302   local i   local bootdev
303    
304   if [[ -z ${installdevs} ]]   # all disks but exclude ramdisks
305     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
306     # remove the boot device from ALL_DISKS if it was an usbstick
307     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
308   then   then
309   dialog \   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
310   --backtitle "${TITLE}" \   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
311   fi   fi
312     export ALL_CDROMS="$(get_hwinfo cdrom)"
313  }  }
314    
315  dialog_setup_hdd_create_partitions()  dialog_setup_hdd_create_partitions()
# Line 431  dialog_main() Line 400  dialog_main()
400   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
401   then   then
402   case ${METHOD} in   case ${METHOD} in
403           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
404   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
405   "3") install_do_reboot ;;   "3") install_do_reboot ;;
406   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 505  hdd_size_below_256mb() Line 474  hdd_size_below_256mb()
474   local hdd="$1"   local hdd="$1"
475   local size   local size
476   local retval   local retval
477   [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"   [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
478    
479   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
480   if [[ ${size} -le 257000000 ]]   if [[ ${size} -le 257000000 ]]
# Line 534  setup_hdd_partitions_auto() Line 503  setup_hdd_partitions_auto()
503   fi   fi
504    
505   ## delete disk   ## delete disk
506   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
507    
508   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
509   then   then
# Line 582  EOF Line 551  EOF
551    
552  setup_hdd_partitions_manuell()  setup_hdd_partitions_manuell()
553  {  {
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
 {  
554   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
555    
556   ## hdds partitionieren manuell   ## hdds partitionieren manuell
557   cfdisk ${HDD} || die   cfdisk ${HDD} || dialog_die
558  }  }
559    
560  setup_hdd_format()  setup_hdd_format()
561  {  {
562   mkswap ${SWAPHDD} || die   mke2fs -j -q ${ROOTHDD} || dialog_die
  mke2fs -j -q ${BOOTHDD} || die  
  mke2fs -j -q ${ROOTHDD} || die  
 }  
   
 setup_hdd_format_flash()  
 {  
  mke2fs -j -q ${ROOTHDD} || die  
563  }  }
564    
565  install_mount_rootfs()  install_mount_rootfs()
566  {  {
567   swapon ${SWAPHDD} || die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
568   mount ${ROOTHDD} ${INSTALLPATH} || die   install -d ${INSTALLROOT}/boot || dialog_die
569   install -d ${INSTALLPATH}/boot || die   cd ${INSTALLROOT} || dialog_die
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
570  }  }
571    
572  install_system_image()  install_system_image()
573  {  {
574   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
575  }  }
576    
577  install_bootsector_chroot()  install_bootsector_chroot()
578  {  {
579   local my_roothdd   local my_roothdd
580   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf=${INSTALLROOT}/boot/grub/grub.conf
581   local grub2conf=/boot/grub/grub.cfg   local grub2conf=/boot/grub/grub.cfg
582    
583   # check for grub2   # check for grub2
584   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
585   then   then
586   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
587   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
588   then   then
589   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
590   fi   fi
591    
592   # set kernelopts   # set kernelopts
593   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
594   then   then
595   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
596   else   else
597   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || die   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die
598   fi   fi
599   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || die   echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
600   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
601   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
602   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || die   echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
603    
604   # grub-legacy   # grub-legacy
605   else   else
606   ### grubconf schreiben   ### grubconf schreiben
607   source ${INSTALLPATH}/boot/kernelversion   source ${INSTALLROOT}/boot/kernelversion
608    
609   #for alx only   #for alx only
610   if [ -e ${INSTALLPATH}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/alx_version ]
611   then   then
612   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
613   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
614   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
615   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
616   fi   fi
# Line 684  install_bootsector_chroot() Line 627  install_bootsector_chroot()
627   my_roothdd="${ROOTHDD}"   my_roothdd="${ROOTHDD}"
628   fi   fi
629    
630   : > ${grubconf} || die   : > ${grubconf} || dialog_die
631   echo "default 0" >> ${grubconf} || die   echo "default 0" >> ${grubconf} || dialog_die
632   echo "timeout 3" >> ${grubconf} || die   echo "timeout 3" >> ${grubconf} || dialog_die
633   # using current root password   # using current root password
634   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || die   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die
635    
636   echo  >> ${grubconf} || die   echo  >> ${grubconf} || dialog_die
637   echo "# normal boot" >> ${grubconf} || die   echo "# normal boot" >> ${grubconf} || dialog_die
638   echo "title ${KRNVER}" >> ${grubconf} || die   echo "title ${KRNVER}" >> ${grubconf} || dialog_die
639   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
640   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die
641   if is_initrd_supported   if is_initrd_supported
642   then   then
643   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
644   fi   fi
645    
646   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
647   echo "# admin boot" >> ${grubconf} || die   echo "# admin boot" >> ${grubconf} || dialog_die
648   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || die   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die
649   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
650   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
651   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die
652   if is_initrd_supported   if is_initrd_supported
653   then   then
654   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
655   fi   fi
656    
657   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
658   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || die   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die
659   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
660   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
661   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die
662   if is_initrd_supported   if is_initrd_supported
663   then   then
664   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
665   fi   fi
666    
667   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
668   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
669  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
670  root (hd0,0)  root (hd0,0)
671  setup (hd0)  setup (hd0)
# Line 732  exit 0 Line 675  exit 0
675  CHROOTEOF  CHROOTEOF
676   fi   fi
677    
678   ## enters chroot   ## enter chroot
679   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
680   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
681   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
682   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
683   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
684   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
685   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
686   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
687  }  }
688    
689  is_initrd_supported()  is_initrd_supported()
690  {  {
691   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
692   [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0   [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0
693   return 1   return 1
694  }  }
695    
# Line 777  install_initrd_chroot() Line 720  install_initrd_chroot()
720   fi   fi
721    
722   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
723   install -d ${INSTALLPATH}/etc/modprobe.d || die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
724   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || die   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
725    
726   # install an appropriate viafb.conf   # install an appropriate viafb.conf
727   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || die   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
728    
729   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
730   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || die   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
731    
732   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
733  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
734  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
735  exit 0  exit 0
736  CHROOTEOF  CHROOTEOF
737    
738   ## enters chroot   ## enters chroot
739   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
740   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
741   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
742   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
743   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
744   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
745   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
746   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
747  }  }
748    
749  is_uuid_supported()  is_uuid_supported()
750  {  {
751   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
752   then   then
753   # only detect uuids if supported   # only detect uuids if supported
754   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 824  get_uuid() Line 767  get_uuid()
767   local TYPE   local TYPE
768    
769   local dev="$1"   local dev="$1"
770   [[ -z ${dev} ]] && die "no dev given"   [[ -z ${dev} ]] && dialog_die "no dev given"
771    
772   # check if given device is already an UUID   # check if given device is already an UUID
773   if [[ ${dev/UUID=/}x != ${dev}x ]]   if [[ ${dev/UUID=/}x != ${dev}x ]]
# Line 841  install_system_settings() Line 784  install_system_settings()
784   # schreibe fstab   # schreibe fstab
785   if is_uuid_supported   if is_uuid_supported
786   then   then
787   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
788   else   else
789   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
790   fi   fi
791   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
792   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
793   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
794   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
795    
796   # install network config skeleton   # install network config skeleton
797   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die
798    
799   # intel framebufer quirk   # intel framebufer quirk
800   if [[ -e /proc/fb ]]   if [[ -e /proc/fb ]]
# Line 863  install_system_settings() Line 804  install_system_settings()
804   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
805   if [[ ${fbdev} != 0 ]]   if [[ ${fbdev} != 0 ]]
806   then   then
807   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || die   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
808   fi   fi
809   fi   fi
810   fi   fi
811  }  }
812    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
 }  
   
813  install_umount_rootfs()  install_umount_rootfs()
814  {  {
815   cd /   cd /
816   umount ${INSTALLPATH}/boot || die   umount ${INSTALLROOT}/boot || dialog_die
817   umount ${INSTALLPATH} || die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || die  
818  }  }
819    
820  install_do_reboot()  install_do_reboot()
# Line 927  run_install_normal() Line 848  run_install_normal()
848   dialog_install_successful   dialog_install_successful
849  }  }
850    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
851  run_install_auto()  run_install_auto()
852  {  {
853   dialog_hardware_detection   dialog_hardware_detection
854    
855   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
856   dialog_setup_hdd_format   dialog_setup_hdd_format
857   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
858   install_mount_rootfs_flash   install_mount_rootfs
859   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
860    
861   dialog_install_settings   dialog_install_settings
862   sleep 1   sleep 1
863   install_system_settings_flash   install_system_settings
864   install_initrd_chroot   install_initrd_chroot
865    
866   dialog_install_bootsector   dialog_install_bootsector
867   install_bootsector_chroot   install_bootsector_chroot
868    
869   install_umount_rootfs_flash   install_umount_rootfs
870   dialog_install_successful   dialog_install_successful
871  }  }
872    

Legend:
Removed from v.2321  
changed lines
  Added in v.2401